package pathgame.rendering;

import me.hammerle.snuviengine.api.Renderer;
import me.hammerle.snuviengine.api.Texture;
import pathgame.gameplay.Player;
import pathgame.tilemap.TileMap;

public class PlayerRenderer
{

    private static final Texture CHARACTER = new Texture("res/character/characterFront.png");
    private static final Texture CHARACTERLEFT = new Texture("res/character/characterLeft.png");
    private static final Texture CHARACTERRIGHT = new Texture("res/character/characterRight.png");
    private static final Texture CHARACTERBACK = new Texture("res/character/characterBack.png");

    public void renderTick(TileMap map, TileMapRenderer mapR, Renderer r, Player p, float lag, float offX, float offY)
    {
        float playerSize = mapR.getScale() * TileRenderer.TILE_SIZE;

        r.setMixColorEnabled(false);
        r.setColorEnabled(false);
        r.setTextureEnabled(true);

        r.translateTo(0.0f, 0.0f);
        r.updateMatrix();

        //TODO: insert animations
        if(p.getVelX() > 0)
        {
            CHARACTERRIGHT.bind();
        }
        else if(p.getVelX() < 0)
        {
            CHARACTERLEFT.bind();
        }
        else if(p.getVelY() > 0)
        {
            CHARACTER.bind();
        }
        else if(p.getVelY() < 0)
        {
            CHARACTERBACK.bind();
        }
        else
        {
            CHARACTER.bind();
        }

        float baseX = (p.getLastX() + (p.getX() - p.getLastX()) * lag);
        float ix = baseX * mapR.getScale() * TileRenderer.TILE_SIZE + offX;

//        //TODO: refactor
//        baseX = baseX - (int) baseX;
//        int tIndex = 0;
//        if(baseX <= 0.125f)
//        {
//            tIndex = 0;
//        }
//        else if(baseX <= 0.375f)
//        {
//            tIndex = 1;
//        }
//        else if(baseX <= 0.625f)
//        {
//            tIndex = 2;
//        }
//        else if(baseX <= 0.875f)
//        {
//            tIndex = 3;
//        }
//        
//        System.out.println(baseX);
        float iy = (p.getLastY() + (p.getY() - p.getLastY()) * lag) * mapR.getScale() * TileRenderer.TILE_SIZE + offY;
//        r.getTextureRenderer().drawRectangle(ix, iy, ix + playerSize, iy + playerSize, 
//                tIndex * 0.25f, 0.0f, (tIndex + 1) * 0.25f, 1.0f);
r.getTextureRenderer().drawRectangle(ix, iy, ix + playerSize, iy + playerSize, 
                0.0f, 0.0f, 1.0f, 1.0f);
    }
}
